-- ================================================================== --
-- SISTEMA         : PEDIDO                                           --
-- DATA DA CRIAO : INCIO - 03/02/2004                              --
-- CRIAO         : Andr Rodrigo                                    --
-- OBJETIVO        : Altera o valor dos itens do pedido               --
-- ================================================================== --
IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ALTERA_PRECOITENS' AND
	              TYPE = 'P' 			          AND
      	        U.UID = O.UID                AND
      	        U.NAME = USER)
DROP PROCEDURE ALTERA_PRECOITENS
GO
CREATE PROCEDURE ALTERA_PRECOITENS @P_CDFILIAL      VARCHAR(4),
                                   @P_NRPEDIDO      VARCHAR(10),
                                   @P_CDPRECOBASE   VARCHAR(2),
                                   @P_NRERRO        INTEGER OUTPUT
AS

  DECLARE @V_VRITEPREBASE  DOUBLE PRECISION;
  DECLARE @V_VRDESITEM     DOUBLE PRECISION;
  DECLARE @V_VRPEDESC      DOUBLE PRECISION;

  DECLARE @V_CDFILIAL      VARCHAR(4);
  DECLARE @V_NRPEDIDO      VARCHAR(10);
  DECLARE @V_NRITEMPED     VARCHAR(10);
  DECLARE @V_CDPRODUTO     VARCHAR(10);
  DECLARE @V_DTPEDIDO      DATETIME;
  DECLARE @V_VRDESITPED    DOUBLE PRECISION;
  DECLARE @V_VRPREUNITPED  DOUBLE PRECISION;
BEGIN
   SET @P_NRERRO = 0;
   DECLARE C_ITEM CURSOR FOR
   SELECT
      PE.CDFILIAL, PE.NRPEDIDO,   IT.NRITEMPED,  IT.CDPRODUTO,
      PE.DTPEDIDO, IT.VRDESITPED, IT.VRPREUNITPED
   FROM ITEMPEDIDO IT, PEDIDO PE
   WHERE PE.CDFILIAL    = @P_CDFILIAL
     AND PE.NRPEDIDO    = @P_NRPEDIDO
     AND IT.CDFILIAL    = PE.CDFILIAL
     AND IT.NRPEDIDO    = PE.NRPEDIDO
     AND IT.IDSITITEMPED IN ('1', '2')
   OPEN C_ITEM;

   FETCH NEXT FROM C_ITEM INTO @V_CDFILIAL, @V_NRPEDIDO,   @V_NRITEMPED, @V_CDPRODUTO,
                               @V_DTPEDIDO, @V_VRDESITPED, @V_VRPREUNITPED;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT V_VRITEPREBASE = MAX(VRITEPREBASE)
      FROM ITEMPREBASE
      WHERE CDPRECOBASE =  @P_CDPRECOBASE
        AND CDPRODUTO   =  @V_CDPRODUTO;


      IF (@V_VRITEPREBASE > 0) BEGIN
         SET @V_VRDESITEM = @V_VRDESITPED;
         IF (@V_VRDESITPED > 0) BEGIN
            SET @V_VRPEDESC  = (@V_VRDESITPED * 100)/@V_VRPREUNITPED;
            SET @V_VRDESITEM = (@V_VRITEPREBASE * @V_VRPEDESC)/100;
         END;

         UPDATE ITEMPEDIDO
         SET VRPREUNITPED = @V_VRITEPREBASE,
             VRPRTABITPED = @V_VRITEPREBASE,
             VRDESITPED   = @V_VRDESITEM
         WHERE CDFILIAL  = @V_CDFILIAL
           AND NRPEDIDO  = @V_NRPEDIDO
           AND NRITEMPED = @V_NRITEMPED;
      END
      ELSE BEGIN
         SET @P_NRERRO = 1;
      END;

      FETCH NEXT FROM C_ITEM INTO @V_CDFILIAL, @V_NRPEDIDO,   @V_NRITEMPED, @V_CDPRODUTO,
                                  @V_DTPEDIDO, @V_VRDESITPED, @V_VRPREUNITPED;
   END;
   CLOSE C_ITEM;
   DEALLOCATE C_ITEM;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ALTERA_PRECOITENS','4.05.126';
GO

